# if we don't deactivate debug packages there is one strange
# /usr/lib/debug/usr/lib64/U unpacked file on x86_64
%define _enable_debug_packages %{nil}
%define debug_package          %{nil}

%define major 1
%define libname %mklibname %{name} %{major}
%define develname %mklibname %{name} -d

%define epoch	1

Summary:	JavaScript engine
Name:		js
Version:	1.5
Release:	%mkrel 5
License:	MPL
Group:		Development/Other
URL:		http://www.gingerall.com/charlie/ga/xml/d_related.xml
Source0:	%{name}-%{version}.tar.gz
Patch0:		lib%{name}-%{version}.patch
Patch1:		js-va_copy.diff
Patch2:		js-editline.diff
Requires:	%{libname} = %{epoch}:%{version}-%{release}
%if %mdkversion >= 1020
BuildRequires:	multiarch-utils >= 1.0.3
%endif
Epoch:		%{epoch}
BuildRequires:	editline-devel
BuildRoot:	%{_tmppath}/%{name}-buildroot

%description
JavaScript is the Netscape-developed object scripting languages. This
package has been created for purposes of Sablotron and is suitable for 
embedding in applications. See http://www.mozilla.org/js for details 
and sources.

%package -n	%{libname}
Summary:	JavaScript engine library
Group:		System/Libraries
Epoch:		%{epoch}

%description -n	%{libname}
JavaScript is the Netscape-developed object scripting languages. This
package has been created for purposes of Sablotron and is suitable for 
embedding in applications. See http://www.mozilla.org/js for details 
and sources.

%package -n	%{develname}
Summary:	The header files for %{libname}
Group:		Development/C
Requires:	%{libname} = %{epoch}:%{version}-%{release}
Provides:	%{name}-devel = %{epoch}:%{version}-%{release}
Provides:	libjs-devel = %{epoch}:%{version}-%{release}
Obsoletes: %mklibname -d js 1
Epoch:		%{epoch}

%description -n	%{develname}
These are the header files for %{libname}

%prep

%setup -q -n %{name}

for i in `find . -type d -name CVS` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
    if [ -e "$i" ]; then rm -rf $i; fi >&/dev/null
done

cd src
%patch0 -p0 
cd ..
%patch1 -p1 -b .va_copy
%patch2 -p0 -b .editline

%build
cd src
perl -pi -e "s/-shared/-shared -lc -soname libjs.so.1/;" config/Linux_All.mk
#JMD: %make does *not* work!
export CFLAGS="%{optflags} -fno-stack-protector -DPIC -fPIC -D_REENTRANT"
export XCFLAGS="$CFLAGS"

BUILD_OPT=1 make -f Makefile.ref 

# create pkgconfig file
# pkgconfig can't find libjs without it
%{__cat} > libjs.pc << 'EOF'
prefix=%{_prefix}
exec_prefix=%{_prefix}
libdir=%{_libdir}
includedir=%{_includedir}

Name: libjs
Description: %{summary}
Version: %{version}
Libs: -L${libdir} -ljs
Cflags: -I${includedir}/js-%{version}
EOF

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{_includedir}/js-%{version}

# install headers
install -m0644 src/*.h %{buildroot}%{_includedir}/js-%{version}/
install -m0644 src/Linux_All_OPT.OBJ/jsautocfg.h %{buildroot}%{_includedir}/js-%{version}/

# install shared library
install -m0755 src/Linux_All_OPT.OBJ/lib%{name}.so \
    %{buildroot}%{_libdir}/lib%{name}.so.%{major}
ln -snf lib%{name}.so.%{major} %{buildroot}%{_libdir}/lib%{name}.so

# install static library
install -m0644 src/Linux_All_OPT.OBJ/lib%{name}.a %{buildroot}%{_libdir}/

# install binary
install -m0755 src/Linux_All_OPT.OBJ/%{name} %{buildroot}%{_bindir}/

# install pkgconfig file
mkdir -p %{buildroot}%{_libdir}/pkgconfig/
install -m0644 src/libjs.pc %{buildroot}%{_libdir}/pkgconfig/

%if %mdkversion >= 1020
%multiarch_includes %{buildroot}%{_includedir}/js-%{version}/jsautocfg.h
%endif

%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{_bindir}/*

%files -n %{libname}
%defattr(-,root,root)
%doc src/README.html
%{_libdir}/*.so.*

%files -n %{develname}
%defattr(-,root,root)
%dir %{_includedir}/js-%{version}
%if %mdkversion >= 1020
%multiarch %{multiarch_includedir}/js-%{version}/jsautocfg.h
%endif
%{_includedir}/js-%{version}/*
%{_libdir}/*.so
%{_libdir}/*.a
%{_libdir}/pkgconfig/*.pc


%changelog
* Mon Feb 04 2008 Götz Waschk <waschk@mandriva.org> 1.5-5mdv2008.1
+ Revision: 161913
- fix devel provides and obsoletes

* Sun Jan 13 2008 Thierry Vignaud <tvignaud@mandriva.com> 1:1.5-4mdv2008.1
+ Revision: 150422
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Wed Aug 29 2007 Oden Eriksson <oeriksson@mandriva.com> 1:1.5-3mdv2008.0
+ Revision: 73850
- bump release
- 1.5
- rediffed patches
- build it against system editline libs
- have to use -fno-stack-protector, otherwise it won't build


* Wed Oct 11 2006 Oden Eriksson <oeriksson@mandriva.com>
+ 2006-10-10 18:04:13 (63395)
- bunzip patches

* Wed Oct 11 2006 Oden Eriksson <oeriksson@mandriva.com>
+ 2006-10-10 17:59:17 (63394)
- Import js

* Fri Sep 01 2006 UTUMI Hirosi <utuhiro78@yahoo.co.jp> 1.5-0.rc5a.10mdv2007.0
- add pkgconfig file

* Fri Feb 10 2006 Oden Eriksson <oeriksson@mandriva.com> 1.5-0.rc5a.9mdk
- rebuild

* Mon Jan 31 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 1.5-0.rc5a.8mdk
- fix deps and conditional %%multiarch

* Wed Dec 29 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.5-0.rc5a.7mdk
- revert latest "lib64 fixes"

* Wed Dec 29 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.5-0.rc5a.6mdk
- lib64 fixes

* Mon Nov 22 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.5-0.rc5a.5mdk
- relocate the headers as many dev moz packages seems to conflict
- nuke redundant provides

* Thu Sep 30 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.5-0.rc5a.4mdk
- fix fork off mozilla/js, our system knows about ISO C va_copy() macro

* Sun Jun 20 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.5-0.rc5a.3mdk
- fix ppc build

* Tue Jun 08 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.5-0.rc5a.2mdk
- third try... (duh!)

* Tue Jun 08 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.5-0.rc5a.1mdk
- second try...

* Tue Jun 08 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.5-0.rc5a.1mdk
- 1.5-0.rc5a

* Mon Jun 07 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.5-0.rc5.6mdk
- rebuilt with gcc v3.4.x

